#include <stdio.h>
#include <somd.hh>
#pragma SOMNoDataDirect(on)
#include "info.hh"
#pragma SOMNoDataDirect(pop)

int main(int argc, char *argv[])
{
    Info       *foo;
    SOMDServer	*server;
    Environment *__SOMEnv;   // This is a special name, don't change it.

    __SOMEnv = SOM_CreateLocalEnvironment();
    printf("After create local env\n");

    SOMD_Init(__SOMEnv);
    printf("After DSOM init\n");

    Info anInfo;
    printf("Local anInfo.x = %d\n", anInfo.x);

    server = SOMD_ObjectMgr->somdFindServerByName("CLau");
    printf("After find server\n");

    if (server)
    {
      foo = (Info *) server->somdCreateObj("info","");
      printf("Creation attempted.\n");
      if(foo)
	 printf("Remote Info.x = %d\n", foo->x);
      else
	 printf("Failed to create remote object\n");
    }

    SOMD_Uninit(__SOMEnv);
    SOM_DestroyLocalEnvironment(__SOMEnv);

    return(0);
}
